from kivy.uix.boxlayout import BoxLayout
from kivy.app import App
from kivy.factory import Factory

customItemNumber = 0
markupFactor = 1.2


class StoreItem:
    itemID = "unknown"
    name = "unknown"
    cost = 0.00
    price = 0.00

    def __init__(self, newCost=None, newName=None, UPC=None):
        global customItemNumber
        global markupFactor
        if newCost is not None:
            self.cost = newCost
        if newName is not None:
            self.name = newName
        if UPC is not None:
            self.itemID = UPC
        else:
            self.itemID = str(customItemNumber)
            customItemNumber = customItemNumber + 1
        self.price = self.cost * markupFactor
        self.price = round(self.price, 2)

inventoryList = list()

inventoryList.append(StoreItem(newCost=2.00, newName="Bread", UPC="10009999"))
inventoryList.append(StoreItem(newCost=.83, newName="MYBRAND Napkins", UPC="44440001"))
#Since we are using python, you do not have to have all of the parameters:
inventoryList.append(StoreItem(newCost=.68, newName="Apple"))
inventoryList.append(StoreItem(newCost=.50, UPC="12340001"))
inventoryList.append(StoreItem(newCost=3.00))

class MainForm(BoxLayout):
    subtotal = 0.00
    total = 0.00
    salestaxRate = 0.06
    cart = list()

    def form1Load(self):
        global inventoryList
        for thisItem in inventoryList:
            self.inventoryGridLayout.add_widget(Factory.Label(text=thisItem.itemID))
            self.inventoryGridLayout.add_widget(Factory.Label(text=thisItem.name))
            self.inventoryGridLayout.add_widget(Factory.Label(text=str(thisItem.price)))

    def addClick(self, instance):
        self.cartListView.item_strings.append(self.itemTextInput.text)


class ShoppingCartApp(App):
    def build(self):
        form = MainForm()
        form.orientation='vertical'
        form.inventoryGridLayout = Factory.GridLayout(id="inventoryGridLayout", size_hint=(1.0,0.3), cols=3)
        form.add_widget(form.inventoryGridLayout)
        form.itemTextInput = Factory.TextInput(id="itemTextInput", size_hint=(1.0,0.1), multiline=False)
        form.add_widget(form.itemTextInput)
        form.addButton = Factory.Button(id="addButton", size_hint=(1.0,0.1), text="Add to Cart")
        form.addButton.bind(on_press=form.addClick)
        form.add_widget(form.addButton)
        form.cartListView = Factory.ListView(id="cartListView", size_hint=(1.0,0.3))
        form.add_widget(form.cartListView)
        form.subtotalLabel = Factory.Label(id="subtotalLabel", size_hint=(1.0,0.1), text="SUBTOTAL")
        form.add_widget(form.subtotalLabel)
        form.totalLabel = Factory.Label(id="totalLabel", size_hint=(1.0,0.05), text="TOTAL")
        form.add_widget(form.totalLabel)
        form.statusLabel = Factory.Label(id="statusLabel", size_hint=(1.0,0.05))
        form.add_widget(form.statusLabel)
        form.form1Load()
        return form

if __name__ == '__main__':
    ShoppingCartApp().run()

